#include <M5Stack.h>
#include <Wire.h>
#include <WiFi.h>
#include <WiFiUDP.h>
#define FACES_KEYBOARD_I2C_ADDR 0x08

static WiFiUDP udp; 
static const int rport = 9000; //送信先のポート
static const int lport = 7000;  //自身のポート
String str="";
String lip="";
String msg="";
int lmsg=7;
int lptr=0;
int rp[]={192,168,0,0};
String rip="";
char ripc[50];
int setM=0;

void drawLcd(String s) {
  M5.Lcd.clear();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_YELLOW,TFT_BLACK);
  M5.Lcd.setCursor(0,0); M5.Lcd.print("< M5 Rapiro Controller >");
  M5.Lcd.setCursor(0,20); M5.Lcd.print("My IP:"+lip);
  M5.Lcd.setCursor(0,40); M5.Lcd.print("Setting Mode:"+String(setM));
  rip=String(rp[0])+"."+String(rp[1])+"."+String(rp[2])+"."+String(rp[3]);
  M5.Lcd.setCursor(0,60); M5.Lcd.print("RcvIP:"+rip);
  M5.Lcd.setCursor(0,100); M5.Lcd.print(s);
}

void setup() {
  M5.begin();
  Wire.begin();
  M5.Lcd.clear();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(TFT_YELLOW,TFT_BLACK);
  M5.Lcd.setCursor(0,0); M5.Lcd.print("< M5 Rapiro Controller >");
  M5.Lcd.setCursor(0,40); M5.Lcd.print("Home WiFi  : Press Btn A");
  M5.Lcd.setCursor(0,60); M5.Lcd.print("Mobile WiFi: Press Btn B");
  const char* ssid;
  const char* password;
  while (1){
    if (M5.BtnA.wasPressed()){
      lip="192.168.64.xx";
      rp[0]=192; rp[1]=168; rp[2]=64; rp[3]=40;
      ssid = "078826693431";
      password = "63414115";
      M5.Lcd.setCursor(0,100); M5.Lcd.print("Home WiFi was Selected");
      break;
    } else if(M5.BtnB.wasPressed()){
      lip="192.168.100.xx";
      rp[0]=192; rp[1]=168; rp[2]=100; rp[3]=100;
      ssid = "SPWN_H36_401C4D";
      password = "9r0tqd61mj0h8fn";
      M5.Lcd.setCursor(0,100); M5.Lcd.print("Mobile WiFi was Selected");
      break;
    }
    M5.update();
    delay(100);
  }
  WiFi.mode(WIFI_STA);                    // 無線LANをSTAモードに設定
  WiFi.begin(ssid,password);                  // 無線LANアクセスポイントへ接続
  while(WiFi.status() != WL_CONNECTED){   // 接続に成功するまで待つ
    delay(500);                        // 待ち時間処理
  }  

  lip=WiFi.localIP().toString();

  while(1){
    if(M5.BtnA.wasPressed()){
      ++setM; if (setM>4) setM=0;
      drawLcd("");
    } else if (M5.BtnB.wasPressed() && setM<4 && rp[setM]>0 ){
      --rp[setM]; drawLcd("");
    } else if (M5.BtnC.wasPressed() && setM<4 && rp[setM]<255){
      ++rp[setM]; drawLcd("");
    } else if (setM==4 && (M5.BtnB.wasPressed() || M5.BtnC.wasPressed())){
      break;
    }
    M5.update();
    delay(100);
  }
  rip.toCharArray(ripc,50);
  delay(100);
  udp.begin(rport);
  msg="Ready!";
  drawLcd(msg);
}

void loop() {
  Wire.requestFrom(FACES_KEYBOARD_I2C_ADDR, 1);
  int c;
  while (Wire.available()) {
    c = Wire.read(); // receive a byte as character
    int nservo=-1;
    if (c=='A') {nservo=0; msg="0";}
    else if(c=='M') {nservo=1; msg="1";}
    else if(c=='%') {nservo=2; msg="2";}
    else if(c=='/') {nservo=3; msg="3";}
    
    else if(c=='7') {nservo=4; msg="4";} 
    else if(c=='8') {nservo=5; msg="5";}
    else if(c=='9') {nservo=6; msg="6";}
    else if(c=='*') {nservo=7; msg="7";}
    else if(c=='4') {nservo=8; msg="8";} 
    else if(c=='5') {nservo=9; msg="9";}
    else if(c=='6') {nservo=10; msg="10";}
    else if(c=='-') {nservo=11; msg="11";}
    else if(c=='1') {nservo=12; msg="12";} 
    else if(c=='2') {nservo=13; msg="13";}
    else if(c=='3') {nservo=14; msg="14";}
    else if(c=='+') {nservo=15; msg="15";}
   
    if (nservo>=0 && nservo<16){
      udp.beginPacket(ripc,rport);  // 送信パケットの開始
      udp.write(c);                   // 送信メッセージを送信
      udp.endPacket();                    // 送信パケットの終了
      delay(50);
      drawLcd(msg);
    }
    delay(50);
  }
}
